2 # some elements originated from qemu configure
5 TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6 TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7 TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8 trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
27 $CC -E -dD $CFLAGS include/arm_features.h | grep -q "$1" || return 1
33 $CC -E -dD $CFLAGS include/arm_features.h | grep "$1" | awk '{print $3}'
37 # setting options to "yes" or "no" will make that choice default,
38 # "" means "autodetect".
40 platform_list="generic pandora maemo caanoo libretro"
42 builtin_gpu_list="neon peops unai"
44 sound_driver_list="oss alsa pulseaudio sdl libretro"
46 plugins="plugins/spunull/spunull.so \
47 plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
64 # these are for known platforms
65 optimize_cortexa8="no"
66 optimize_arm926ej="no"
69 if [ "${OSTYPE}" = "FreeBSD" ]; then
72 CFLAGS="-I/usr/local/include -L/usr/local/lib"
75 CC="${CC-${CROSS_COMPILE}gcc}"
76 CXX="${CXX-${CROSS_COMPILE}g++}"
78 AS="${AS-${CROSS_COMPILE}as}"
79 AR="${AS-${CROSS_COMPILE}ar}"
80 MAIN_LDLIBS="$LDLIBS -ldl -lm -lpthread"
81 config_mak="config.mak"
83 if [ "${OSTYPE}" = "FreeBSD" ]; then
85 [ "x${SDL_CONFIG}" = "x" ] && SDL_CONFIG="${SYSROOT}/usr/local/bin/sdl-config"
87 SYSROOT="$(${CC} --print-sysroot)"
88 [ "x${SDL_CONFIG}" = "x" ] && SDL_CONFIG="${SYSROOT}/usr/bin/sdl-config"
94 if test -n "$DUMP_CONFIG_LOG"; then cat config.log; fi
98 # call during arg parsing, so that cmd line can override platform defaults
106 sound_drivers="oss alsa"
108 optimize_cortexa8="yes"
114 optimize_cortexa8="yes"
120 optimize_arm926ej="yes"
124 sound_drivers="libretro"
128 fail "unsupported platform: $platform"
134 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
136 --help|-h) show_help="yes"
138 --platform=*) set_platform "$optarg"
140 --gpu=*) builtin_gpu="$optarg"
142 --sound-drivers=*) sound_drivers="$optarg"
144 --enable-neon) have_arm_neon="yes"
146 --disable-neon) have_arm_neon="no"
148 --disable-dynarec) enable_dynarec="no"
150 *) echo "ERROR: unknown option $opt"; show_help="yes"
155 if [ "$show_help" = "yes" ]; then
157 echo " --help print this message"
158 echo " --platform=NAME target platform [$platform]"
159 echo " available: $platform_list"
160 echo " --gpu=NAME builtin gpu plugin [guessed]"
161 echo " available: $builtin_gpu_list"
162 echo " --sound-drivers=LIST sound output drivers [guessed]"
163 echo " available: $sound_driver_list"
164 echo " --enable-neon"
165 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
166 echo " --disable-dynarec disable dynamic recompiler"
167 echo " (dynarec is only available and enabled on ARM)"
168 echo "influential environment variables:"
169 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
173 # validate selections
174 if [ "x$builtin_gpu" != "x" ]; then
175 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
176 fail "unsupported builtin gpu plugin: $builtin_gpu"
180 if [ "x$sound_drivers" != "x" ]; then
181 for d in $sound_drivers; do
182 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
183 fail "unsupported sound driver: $sound_driver"
188 if [ "$need_libpicofe" = "yes" ]; then
189 if ! test -f "frontend/libpicofe/README"; then
190 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
194 if [ "$need_warm" = "yes" ]; then
195 if ! test -f "frontend/warm/README"; then
196 fail "wARM is missing, please run 'git submodule init && git submodule update'"
200 # basic compiler test
203 int main(void) { return 0; }
205 if ! compile_binary; then
206 fail "compiler test failed, please check config.log"
209 if [ -z "$ARCH" ]; then
210 ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'`
218 if [ "$optimize_cortexa8" = "yes" ]; then
219 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
220 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
222 if [ "$optimize_arm926ej" = "yes" ]; then
223 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
224 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
227 if [ "x$have_arm_neon" = "x" ]; then
228 # detect NEON from user-supplied cflags to enable neon code
229 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
231 if [ "x$have_armv7" = "x" ]; then
232 if check_define HAVE_ARMV7; then
238 if [ "x$have_armv6" = "x" ]; then
239 if check_define HAVE_ARMV6; then
244 if [ "x$have_armv5" = "x" ]; then
245 have_armv5=`check_define HAVE_ARMV5 && echo yes` || true
248 if [ "x$builtin_gpu" = "x" ]; then
249 if [ "$have_arm_neon" = "yes" ]; then
251 elif [ "$have_armv7" != "yes" ]; then
252 # pre-ARMv7 hardware is usually not fast enough for peops
259 # automatically set mfpu and mfloat-abi if they are not set
260 if [ "$have_arm_neon" = "yes" ]; then
262 elif [ "$have_armv6" = "yes" ]; then
265 if [ "x$fpu" != "x" ]; then
266 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
267 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
268 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
269 if [ "$floatabi_set_by_gcc" != "yes" ]; then
270 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
271 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
275 # must disable thumb as recompiler can't handle it
276 if check_define __thumb__; then
277 CFLAGS="$CFLAGS -marm"
280 # warn about common mistakes
281 if [ "$have_armv5" != "yes" ]; then
282 if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then
283 echo "Warning: compiling for ARMv4, is that really what you want?"
284 echo "You probably should specify -mcpu= or -march= like this:"
285 echo " CFLAGS=-march=armv6 ./configure ..."
288 if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then
289 echo "Warning: compiling for NEON, but not ARMv7?"
290 echo "You probably want to specify -mcpu= or -march= like this:"
291 echo " CFLAGS=-march=armv7-a ./configure ..."
293 have_arm_neon_asm=$have_arm_neon
297 have_arm_neon_asm="no"
298 if [ "x$builtin_gpu" = "x" ]; then
304 if [ "x$builtin_gpu" = "x" ]; then
309 # dynarec only available on ARM
314 if [ "x$builtin_gpu" = "x" ]; then
318 # supposedly we can avoid -fPIC on armv5 for slightly better performace?
319 if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
320 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
328 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES"
331 CFLAGS="$CFLAGS -fPIC"
332 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
336 # header/library presence tests
341 int main(void) { uncompress(0, 0, 0, 0); }
350 void main() { png_init_io(0, 0); }
358 #include <sys/soundcard.h>
359 #include <sys/ioctl.h>
360 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
368 #include <alsa/asoundlib.h>
369 void main() { snd_pcm_open(0, 0, 0, 0); }
377 #include <pulse/pulseaudio.h>
378 void main() { pa_threaded_mainloop_new(); }
387 void main() { SDL_OpenAudio(0, 0); }
395 #include <X11/Xlib.h>
396 void *f() { return XOpenDisplay(0); }
401 # see if we have c64_tools for TI C64x DSP
405 #include <inc_libc64_mini.h>
406 int f() { return dsp_open(); }
411 MAIN_LDLIBS="$MAIN_LDLIBS -lz"
412 check_zlib || fail "please install zlib (libz-dev)"
414 MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
415 check_libpng || fail "please install libpng (libpng-dev)"
417 # find what audio support we can compile
418 if [ "x$sound_drivers" = "x" ]; then
419 if check_oss; then sound_drivers="$sound_drivers oss"; fi
420 if check_alsa -lasound; then
421 sound_drivers="$sound_drivers alsa"
422 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
424 if check_pulseaudio -lpulse; then
425 sound_drivers="$sound_drivers pulseaudio"
426 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
428 if [ "$need_sdl" = "yes" ] || check_sdl `${SDL_CONFIG} --cflags --libs`; then
429 sound_drivers="$sound_drivers sdl"
433 if echo $sound_drivers | grep -q "\<oss\>"; then
434 check_oss || fail "oss support is missing"
436 if echo $sound_drivers | grep -q "\<alsa\>"; then
437 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
438 check_alsa || fail "please install libasound2-dev"
440 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
441 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
442 check_pulseaudio || fail "pulseaudio support is missing"
446 if [ "$need_sdl" = "yes" ]; then
447 which ${SDL_CONFIG} > /dev/null || \
448 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
449 CFLAGS="$CFLAGS `${SDL_CONFIG} --cflags`"
450 MAIN_LDLIBS="`${SDL_CONFIG} --libs` $MAIN_LDLIBS"
451 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
454 # check for tslib (only headers needed)
455 if [ "x$have_tslib" = "x" ]; then
458 void test(struct ts_sample sample) {}
460 if compile_object; then
467 # check for VideoCore stuff for Raspberry Pi
468 if [ -d /opt/vc/include -a -d /opt/vc/lib -a "$VIDEOCORE" != "no" ]; then
469 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/interface/vmcs_host/linux"
470 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
471 if [ -f /opt/vc/lib/libbcm_host.so ]; then
472 LDLIBS_GLES="$LDLIBS_GLES -lbcm_host"
478 # check for GLES headers
483 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
486 if [ "$VIDEOCORE" = "yes" ] && compile_binary $CFLAGS_GLES -lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES; then
488 LDLIBS_GLES="-lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES"
489 elif compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
491 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
492 elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
494 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
497 if check_c64_tools; then
501 if [ "$have_gles" = "yes" ]; then
502 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
504 if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
505 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
508 # check for xlib (only headers needed)
509 if [ "x$need_xlib" = "xyes" ]; then
510 check_xlib_headers || fail "please install libx11-dev"
513 sizeof_long=`check_define_val __SIZEOF_LONG__`
514 if [ "x$sizeof_long" = "x4" ]; then
515 CFLAGS="$CFLAGS -D_FILE_OFFSET_BITS=64"
519 void test(void *f, void *d) { fread(d, 1, 1, f); }
521 if compile_object -Wno-unused-result; then
522 CFLAGS="$CFLAGS -Wno-unused-result"
525 # short plugin list for display
526 for p in $plugins; do
528 plugins_short="$p1 $plugins_short"
531 # set things that failed to autodetect to "no"
532 test "x$have_armv6" != "x" || have_armv6="no"
533 test "x$have_armv7" != "x" || have_armv7="no"
534 test "x$have_arm_neon" != "x" || have_arm_neon="no"
535 test "x$have_arm_neon_asm" != "x" || have_arm_neon_asm="no"
536 test "x$have_gles" != "x" || have_gles="no"
537 test "x$have_c64x_dsp" != "x" || have_c64x_dsp="no"
539 echo "architecture $ARCH"
540 echo "platform $platform"
541 echo "built-in GPU $builtin_gpu"
542 echo "sound drivers $sound_drivers"
543 echo "plugins $plugins_short"
544 echo "C compiler $CC"
545 echo "C compiler flags $CFLAGS"
546 echo "libraries $MAIN_LDLIBS"
547 echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
548 echo "enable dynarec $enable_dynarec"
549 if [ "$ARCH" = "arm" -o "$ARCH" = "aarch64" ]; then
550 echo "enable ARM NEON $have_arm_neon"
552 if [ "$ARCH" = "arm" ]; then
553 echo "ARMv7 optimizations $have_armv7"
554 echo "TI C64x DSP support $have_c64x_dsp"
556 echo "tslib support $have_tslib"
557 if [ "$platform" = "generic" ]; then
558 echo "OpenGL ES output $have_gles"
561 echo "# Automatically generated by configure" > $config_mak
562 printf "# Configured with:" >> $config_mak
563 printf " '%s'" "$0" "$@" >> $config_mak
566 echo "CC = $CC" >> $config_mak
567 echo "CXX = $CXX" >> $config_mak
568 echo "AS = $AS" >> $config_mak
569 echo "CFLAGS += $CFLAGS" >> $config_mak
570 echo "ASFLAGS += $ASFLAGS" >> $config_mak
571 echo "LDFLAGS += $LDFLAGS" >> $config_mak
572 echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
573 echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
574 echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
577 if [ "$platform" = "libretro" ]; then
578 echo "TARGET = libretro.so" >> $config_mak
580 echo "ARCH = $ARCH" >> $config_mak
581 echo "PLATFORM = $platform" >> $config_mak
582 echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
583 echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
584 echo "PLUGINS = $plugins" >> $config_mak
585 if [ "$have_arm_neon" = "yes" ]; then
586 echo "HAVE_NEON = 1" >> $config_mak
588 if [ "$have_arm_neon_asm" = "yes" ]; then
589 echo "HAVE_NEON_ASM = 1" >> $config_mak
591 if [ "$have_tslib" = "yes" ]; then
592 echo "HAVE_TSLIB = 1" >> $config_mak
594 if [ "$have_gles" = "yes" ]; then
595 echo "HAVE_GLES = 1" >> $config_mak
596 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
597 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
599 if [ "$enable_dynarec" = "yes" ]; then
600 echo "DYNAREC = ari64" >> $config_mak
602 if [ "$drc_cache_base" = "yes" ]; then
603 echo "BASE_ADDR_DYNAMIC = 1" >> $config_mak
605 if [ "$have_c64x_dsp" = "yes" ]; then
606 echo "HAVE_C64_TOOLS = 1" >> $config_mak
609 # use pandora's skin (for now)
610 test -e skin || ln -s frontend/pandora/skin skin
612 # vim:shiftwidth=2:expandtab